// Generated by CoffeeScript 1.8.0
(function() {
  var ErrorCollector, ErrorListener, ErrorReporter, EventEmitter, ISO_8601_REGEXP, JSONSpec, SINGLE_LINE_REGEXP, URI_REGEXP, Util, data, enum_to_string, fs, json_spec, path, spec, visit,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __slice = [].slice,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  EventEmitter = require('events').EventEmitter;

  fs = require('fs');

  Util = require('inote-util').Util;

  SINGLE_LINE_REGEXP = /\n/;

  ISO_8601_REGEXP = Util.iso_8601_regexp();

  URI_REGEXP = /^[a-z]+\:.+/;

  ErrorListener = (function() {
    function ErrorListener() {
      this.on_errors = __bind(this.on_errors, this);
      this.on_error = __bind(this.on_error, this);
      this.has_error = __bind(this.has_error, this);
      this.error_count = __bind(this.error_count, this);
    }

    ErrorListener.prototype._error_count = 0;

    ErrorListener.prototype.error_count = function() {
      return this._error_count;
    };

    ErrorListener.prototype.has_error = function() {
      return this._error_count > 0;
    };

    ErrorListener.prototype.on_error = function() {
      var message, tail, type;
      type = arguments[0], message = arguments[1], tail = 3 <= arguments.length ? __slice.call(arguments, 2) : [];
      throw new Error("Not implemented");
    };

    ErrorListener.prototype.on_errors = function(errors) {
      var error, _i, _len, _results;
      _results = [];
      for (_i = 0, _len = errors.length; _i < _len; _i++) {
        error = errors[_i];
        _results.push(this.on_error.apply(this, error));
      }
      return _results;
    };

    return ErrorListener;

  })();

  ErrorReporter = (function(_super) {
    __extends(ErrorReporter, _super);

    function ErrorReporter() {
      this.on_error = __bind(this.on_error, this);
      return ErrorReporter.__super__.constructor.apply(this, arguments);
    }

    ErrorReporter.prototype.on_error = function() {
      var message, tail, type;
      type = arguments[0], message = arguments[1], tail = 3 <= arguments.length ? __slice.call(arguments, 2) : [];
      console.error.apply(console, [type, message].concat(__slice.call(tail)));
      return this._error_count++;
    };

    return ErrorReporter;

  })(ErrorListener);

  ErrorCollector = (function(_super) {
    __extends(ErrorCollector, _super);

    function ErrorCollector() {
      this.on_error = __bind(this.on_error, this);
      return ErrorCollector.__super__.constructor.apply(this, arguments);
    }

    ErrorCollector.prototype.errors = [];

    ErrorCollector.prototype.on_error = function() {
      var message, tail, type;
      type = arguments[0], message = arguments[1], tail = 3 <= arguments.length ? __slice.call(arguments, 2) : [];
      return this.errors.push([type, message].concat(__slice.call(tail)));
    };

    return ErrorCollector;

  })(ErrorListener);

  enum_to_string = function(options) {
    if (options.length === 1) {
      return options[0];
    } else {
      return "one of " + Util.smart_join(options, ", ", " or ");
    }
  };

  JSONSpec = (function(_super) {
    __extends(JSONSpec, _super);

    function JSONSpec() {
      this._make_validation_error_message = __bind(this._make_validation_error_message, this);
      this._emit_validation_error = __bind(this._emit_validation_error, this);
      this._debug = __bind(this._debug, this);
      this._validate_attribute = __bind(this._validate_attribute, this);
      this.validate = __bind(this.validate, this);
      this._normalize_attributes = __bind(this._normalize_attributes, this);
      this.normalize = __bind(this.normalize, this);
      this.parse_spec = __bind(this.parse_spec, this);
      this.load_spec = __bind(this.load_spec, this);
      return JSONSpec.__super__.constructor.apply(this, arguments);
    }

    JSONSpec.prototype.load_spec = function(file) {
      var err, src;
      try {
        src = fs.readFileSync(file);
      } catch (_error) {
        err = _error;
        throw new Error("Error loading JSON file at \"" + file + "\".", err);
      }
      try {
        return this.parse_spec(src.toString());
      } catch (_error) {
        err = _error;
        throw err;
      }
    };

    JSONSpec.prototype.parse_spec = function(src) {
      var err;
      if (typeof src === 'string') {
        try {
          src = JSON.parse(src);
        } catch (_error) {
          err = _error;
          throw new Error("Error parsing JSON document.", err);
        }
      }
      return this.normalize(src);
    };

    JSONSpec.prototype.normalize = function(src) {
      var dst, k, v;
      if (src.datatype != null) {
        return this._normalize_attributes(src);
      } else {
        dst = {};
        for (k in src) {
          v = src[k];
          dst[k] = this._normalize_attributes(v);
        }
        return dst;
      }
    };

    JSONSpec.prototype._normalize_attributes = function(src) {
      var dst, e, err, k, s, v, _i, _j, _len, _len1;
      if (Array.isArray(src)) {
        dst = [];
        for (_i = 0, _len = src.length; _i < _len; _i++) {
          s = src[_i];
          dst.push(this._normalize_attributes(s));
        }
        return dst;
      } else {
        dst = {};
        for (k in src) {
          v = src[k];
          switch (k) {
            case 'datatype':
            case 'default':
            case 'description':
              dst[k] = v;
              break;
            case 'attributes':
              dst[k] = this.normalize(v);
              break;
            case 'items':
              dst[k] = this._normalize_attributes(v);
              break;
            case 'enum':
            case 'constraints':
            case 'format':
              if (!Array.isArray(v)) {
                v = [v];
              }
              if (k === 'format') {
                for (_j = 0, _len1 = v.length; _j < _len1; _j++) {
                  e = v[_j];
                  if (typeof e === 'object') {
                    if ((e.matching != null) && typeof e.matching === 'string') {
                      e.matching = new RegExp(e.matching);
                    } else if ((e['not-matching'] != null) && typeof e['not-matching'] === 'string') {
                      e['not-matching'] = new RegExp(e['not-matching']);
                    }
                  }
                }
              }
              dst[k] = v;
              break;
            case 'range':
              if (v.length < 3) {
                v.push("inclusive");
              }
              dst[k] = v;
              break;
            default:
              err = new Error("Specification Error: Found unexpected parameter \"" + k + "\" = \"" + v + "\" in \"" + src + "\".");
              console.error(err);
              throw err;
          }
        }
        if ((dst.items != null) && !dst.datatype === 'array') {
          err = new Error("Specification Error: Found 'items' for non-array datatype \"" + dst.datatype + "\".");
          console.error(err);
          throw err;
        }
        return dst;
      }
    };

    JSONSpec.prototype.validate = function(spec, data, path, error_listener) {
      var k, p, s, v, valid, _ref, _results;
      if (path == null) {
        path = [];
      }
      if (error_listener == null) {
        error_listener = new ErrorReporter();
      }
      valid = true;
      if (path == null) {
        path = [];
      }
      if (spec.datatype != null) {
        if (!this._validate_attribute(spec, data, path, error_listener)) {
          valid = false;
        }
        return valid;
      } else {
        _results = [];
        for (k in data) {
          v = data[k];
          p = [].concat(path);
          p.push(k);
          s = (_ref = spec[k]) != null ? _ref : spec['*'];
          if (s != null) {
            if (!this._validate_attribute(s, v, p, error_listener)) {
              _results.push(valid = false);
            } else {
              _results.push(void 0);
            }
          } else {
            _results.push(this._emit_validation_error(error_listener, data, spec, 'unexpected', path, v, k));
          }
        }
        return _results;
      }
    };

    JSONSpec.prototype._validate_attribute = function(spec, attr, path, error_listener) {
      var alt, elt, error_collector, f, i, k, p, s, v, valid, _i, _j, _k, _len, _len1, _len2, _ref, _ref1;
      if (Array.isArray(spec)) {
        error_collector = new ErrorCollector();
        for (i = _i = 0, _len = spec.length; _i < _len; i = ++_i) {
          alt = spec[i];
          if (this._validate_attribute(alt, attr, path, error_collector)) {
            return true;
          }
        }
        this._emit_validation_error(error_listener, attr, spec, 'no-matching-alt', path, attr, "\n\t" + error_collector.errors.join("\n\t"));
        return false;
      } else {
        valid = true;
        if (attr == null) {
          if (((spec != null ? spec.constraints : void 0) != null) && __indexOf.call(spec.constraints, 'required') >= 0) {
            this._emit_validation_error(error_listener, attr, spec, 'required', path, attr);
            valid = false;
          } else {
            this._debug("ok", "(null)", path);
          }
        } else {
          switch (spec.datatype) {
            case 'string':
              if (typeof attr !== 'string') {
                this._emit_validation_error(error_listener, attr, spec, 'datatype', path, attr, 'string');
                valid = false;
              } else {
                this._debug("ok", "(string)", path);
              }
              break;
            case 'number':
              if (typeof attr !== 'number') {
                this._emit_validation_error(error_listener, attr, spec, 'datatype', path, attr, 'number');
                valid = false;
              } else {
                this._debug("ok", "(number)", path);
              }
              break;
            case 'array':
              if (!Array.isArray(attr)) {
                this._emit_validation_error(error_listener, attr, spec, 'datatype', path, attr, 'array');
                valid = false;
              } else {
                this._debug("ok", "(array)", path);
                for (i = _j = 0, _len1 = attr.length; _j < _len1; i = ++_j) {
                  elt = attr[i];
                  p = [].concat(path);
                  p.push("[" + i + "]");
                  if (!this._validate_attribute(spec.items, elt, p, error_listener)) {
                    valid = false;
                  }
                }
              }
              break;
            case 'map':
              if (typeof attr !== 'object') {
                this._emit_validation_error(error_listener, attr, spec, 'datatype', path, attr, 'object');
              } else {
                this._debug("ok", "(map)", path, spec);
                for (k in attr) {
                  v = attr[k];
                  p = [].concat(path);
                  p.push(k);
                  s = (_ref = spec.attributes[k]) != null ? _ref : spec.attributes['*'];
                  if (s != null) {
                    if (!this._validate_attribute(s, v, p, error_listener)) {
                      valid = false;
                    }
                  } else {
                    valid = false;
                    this._emit_validation_error(error_listener, data, spec, 'unexpected', path, v, k);
                  }
                }
              }
              break;
            default:
              this._emit_validation_error(error_listener, attr, spec, 'not-supported', path, spec.datatype);
              valid = false;
          }
          if (spec["enum"] != null) {
            if (__indexOf.call(spec["enum"], attr) < 0) {
              this._emit_validation_error(error_listener, attr, spec, 'enum', path, attr, spec["enum"]);
              valid = false;
            } else {
              this._debug("ok", "(enum)", path);
            }
          }
          if (spec.range != null) {
            if (spec.range.length === 2 || spec.range[2] === 'inclusive') {
              if (!((spec.range[0] <= attr && attr <= spec.range[1]))) {
                this._emit_validation_error(error_listener, attr, spec, "range", path, attr, spec.range);
                valid = false;
              } else {
                this._debug("ok", "(range)", path);
              }
            } else {
              if (!((spec.range[0] < attr && attr < spec.range[1]))) {
                this._emit_validation_error(error_listener, attr, spec, "range", path, attr, spec.range);
                valid = false;
              } else {
                this._debug("ok", "(range)", path);
              }
            }
          }
          if (spec.format != null) {
            _ref1 = spec.format;
            for (_k = 0, _len2 = _ref1.length; _k < _len2; _k++) {
              f = _ref1[_k];
              if (typeof f === 'string') {
                switch (f) {
                  case 'singleline':
                    if (SINGLE_LINE_REGEXP.test(attr)) {
                      this._emit_validation_error(error_listener, attr, spec, "format-forbidden", path, attr, SINGLE_LINE_REGEXP);
                      valid = false;
                    } else {
                      this._debug("ok", "(singleline)", path);
                    }
                    break;
                  case 'iso8601date':
                    if (!ISO_8601_REGEXP.test(attr)) {
                      this._emit_validation_error(error_listener, attr, spec, "format-required", path, attr, ISO_8601_REGEXP);
                      valid = false;
                    } else {
                      this._debug("ok", "(iso8601date)", path);
                    }
                    break;
                  case 'uri':
                    if (!URI_REGEXP.test(attr)) {
                      this._emit_validation_error(error_listener, attr, spec, "format-required", path, attr, URI_REGEXP);
                      valid = false;
                    } else {
                      this._debug("ok", "(uri)", path);
                    }
                }
              } else if (f.matching != null) {
                if (!f.matching.test(attr)) {
                  this._emit_validation_error(error_listener, attr, spec, "format-required", path, attr, f.matching);
                }
              } else if (f['not-matching'] != null) {
                if (f['not-matching'].test(attr)) {
                  this._emit_validation_error(error_listener, attr, spec, "format-forbidden", path, attr, f['not-matching']);
                }
              }
            }
          }
        }
        this._debug("returning", valid, path);
        return valid;
      }
    };

    JSONSpec.prototype._debug = function() {
      var message, tail, type;
      type = arguments[0], message = arguments[1], tail = 3 <= arguments.length ? __slice.call(arguments, 2) : [];
    };

    JSONSpec.prototype._emit_validation_error = function(listener, data, spec, message_id, path, value, expected) {
      var message;
      message = this._make_validation_error_message(data, spec, message_id, path, value, expected);
      if (message_id === 'no-matching-alt') {
        return listener != null ? listener.on_error("validation-error", message, expected) : void 0;
      } else {
        return listener != null ? listener.on_error("validation-error", message) : void 0;
      }
    };

    JSONSpec.prototype._make_validation_error_message = function(data, spec, message_id, path, value, expected) {
      var message, _ref;
      path = "`" + (path.join('.')) + "`";
      switch (message_id) {
        case 'required':
          message = "Required attribute not found at " + path + ".";
          break;
        case 'datatype':
          message = "Expected datatype \"" + expected + "\" but found " + (typeof value) + " at " + path + ".";
          break;
        case 'enum':
          message = "Expected " + enum_to_string(expected.map(function(x) {
            return "\"" + x + "\"";
          })) + (" but found \"" + value + "\" at " + path + ".");
          break;
        case 'range':
          message = "Expected value between " + expected[0] + " and " + expected[1] + " (" + ((_ref = expected[2]) != null ? _ref : 'inclusive') + ") but found " + value + " at " + path + ".";
          break;
        case 'format-required':
          message = "Expected value to match " + expected + " but found \"" + value + "\" at " + path + ".";
          break;
        case 'format-forbidden':
          message = "Expected value not to match " + expected + " but found \"" + value + "\" at " + path + ".";
          break;
        case 'unexpected':
          message = "Unexpected attribute " + expected + " at " + path + ".";
          break;
        case 'no-matching-alt':
          message = "No matching alternative at " + path + ".";
          break;
        default:
          message = "Validation error (" + message_id + ").";
          if (expected != null) {
            message += " Expected \"" + expected + "\".";
          }
          if (value != null) {
            message += " Found \"" + (JSON.stringify(value)) + "\".";
          }
          message += " At " + path;
      }
      return message;
    };

    return JSONSpec;

  })(EventEmitter);

  exports.JSONSpec = JSONSpec;

  if (require.main === module) {
    if (process.argv.length < 3 || /^-?-?h(elp)?$/.test(process.argv[2])) {
      path = require('path');
      console.error("Use: " + (path.basename(process.argv[1])) + " validate SPEC.JSON DATA.JSON");
      console.error(" or: cat DATA.JSON | " + (path.basename(process.argv[1])) + " validate SPEC.JSON");
      process.exit(1);
    } else {
      json_spec = new JSONSpec();
      spec = json_spec.load_spec(process.argv[3]);
      switch (process.argv[2]) {
        case 'validate':
          if (process.argv.length >= 4) {
            data = Util.load_json_file_sync(process.argv[4]);
          } else {
            data = Util.load_json_stdin_sync();
          }
          if (!json_spec.validate(spec, data)) {
            process.exit(2);
          }
          break;
        case 'normalize':
          console.log(JSON.stringify(spec, null, 2));
          break;
        case 'to-text':
          visit = (function(_this) {
            return function(key, elt, indent) {
              var bracketed, e, i, k, parts, v, _i, _len, _ref, _results;
              if (Array.isArray(elt)) {
                console.log("" + indent + " (alternative formats allowed)");
                indent += "  ";
                _results = [];
                for (i = _i = 0, _len = elt.length; _i < _len; i = ++_i) {
                  e = elt[i];
                  _results.push(visit("(alternative #" + (i + 1) + ")", e, indent));
                }
                return _results;
              } else {
                parts = [];
                if (indent.length > 0) {
                  parts.push(indent);
                }
                if (key != null) {
                  parts.push(key);
                  parts.push(" - ");
                }
                if (elt.description != null) {
                  parts.push(elt.description + " ");
                }
                bracketed = [];
                if (elt.datatype != null) {
                  bracketed.push(elt.datatype);
                }
                if (elt.format != null) {
                  bracketed.push((elt.format.map(function(x) {
                    if (x.matching != null) {
                      return "matching " + x.matching;
                    } else if (x['not-matching']) {
                      return "not matching " + x['not-matching'];
                    } else {
                      return x;
                    }
                  })).join(','));
                }
                if (elt["enum"] != null) {
                  bracketed.push(enum_to_string(elt["enum"].map(function(x) {
                    return "\"" + x + "\"";
                  })));
                }
                if (elt.constraints != null) {
                  bracketed.push(elt.constraints.join(', '));
                }
                if (bracketed.length > 0) {
                  parts.push("[" + (bracketed.join(', ')) + "]");
                }
                console.log(parts.join(""));
                if (elt.attributes != null) {
                  _ref = elt.attributes;
                  for (k in _ref) {
                    v = _ref[k];
                    visit(k, v, indent + "  ");
                  }
                }
                if (elt.items != null) {
                  return visit("(elements)", elt.items, indent + "  ");
                }
              }
            };
          })(this);
          visit(null, spec, "");
          break;
        case 'to-markdown':
          visit = (function(_this) {
            return function(key, elt, indent) {
              var bracketed, e, i, k, parts, v, _i, _len, _ref, _results;
              parts = [];
              if (indent.length > 0) {
                parts.push(indent);
                parts.push(" * ");
              }
              if (key != null) {
                if (key === "*") {
                  parts.push("*(any key)*");
                } else if (key === "(elements)") {
                  parts.push("*(elements)*");
                } else {
                  parts.push("**`" + key + "`**");
                }
                parts.push(" - ");
              } else {
                parts.push("# ");
              }
              if (Array.isArray(elt)) {
                parts.push("(alternative formats allowed)");
                console.log(parts.join(""));
                indent += "  ";
                _results = [];
                for (i = _i = 0, _len = elt.length; _i < _len; i = ++_i) {
                  e = elt[i];
                  _results.push(visit("(alternative #" + (i + 1) + ")", e, indent));
                }
                return _results;
              } else {
                if (elt.description != null) {
                  parts.push("*" + elt.description + "* ");
                }
                bracketed = [];
                if (elt.datatype != null) {
                  bracketed.push(elt.datatype);
                }
                if (elt.format != null) {
                  bracketed.push((elt.format.map(function(x) {
                    if (x.matching != null) {
                      return "matching `" + x.matching + "`";
                    } else if (x['not-matching']) {
                      return "not matching `" + x['not-matching'] + "`";
                    } else {
                      return x;
                    }
                  })).join(', '));
                }
                if (elt["enum"] != null) {
                  bracketed.push(enum_to_string(elt["enum"].map(function(x) {
                    return "\"" + x + "\"";
                  })));
                }
                if (elt.range != null) {
                  bracketed.push("between " + elt.range[0] + " and " + elt.range[1] + ", " + elt.range[2]);
                }
                if (elt.constraints != null) {
                  bracketed.push(elt.constraints.join(', '));
                }
                if (elt["default"] != null) {
                  bracketed.push("defaults to `" + elt["default"] + "`");
                }
                if (bracketed.length > 0) {
                  parts.push("<small style=\"color:#666;\">[" + (bracketed.join(', ')) + "]</small>");
                }
                console.log(parts.join(""));
                if (elt.attributes != null) {
                  _ref = elt.attributes;
                  for (k in _ref) {
                    v = _ref[k];
                    visit(k, v, indent + "  ");
                  }
                }
                if (elt.items != null) {
                  return visit("(elements)", elt.items, indent + "  ");
                }
              }
            };
          })(this);
          visit(null, spec, "");
      }
    }
  }

}).call(this);
